package com.nemo.vidmate.download.service;
import com.nemo.vidmate.download.VideoTask;
import com.nemo.vidmate.download.service.IDownloadCallback;
import com.nemo.vidmate.download.bt.core.Torrent;
import com.nemo.vidmate.download.bt.core.stateparcel.TorrentStateParcel;

interface IDownloadInf
{
	void registerCallback(IDownloadCallback cb);
    void unregisterCallback(IDownloadCallback cb);

	void getTaskList(out List<VideoTask> taskList,boolean isDone);
	
	VideoTask getTaskListEx(int index ,boolean isDone);
	
	void saveTask(in VideoTask vTask);
	void pauseTask(in VideoTask vTask);
	void continueTask(in VideoTask vTask,boolean redownload);	
	long addTask(in VideoTask vTask);
		
	void deleteTasks(in VideoTask vTask,boolean isDeleteFile);
	boolean updateTask(in VideoTask vTask);
	
	void updataRuntime(String key,String val);
	
	oneway void sendActoinX(in List<String> action);
	
	long addFinishTask(in VideoTask vTask);
	boolean isCanNext();

	void addTorrentTask(in Torrent torrent);
	void pauseTorrentTask(in String id);
	void resumeTorrentTask(in String id);
	void deleteTorrentTask(in String id, boolean withFiles);
	void startTorrentEngine();

	List<TorrentStateParcel> getTorrentList(boolean isDone);
}


